﻿
using MySql.Data.MySqlClient;
using System;
using System.Data;
using System.Text;
using System.Threading.Tasks;

namespace ProxySqlBug
{
    internal class Audit
    {
        private const string AUDIT_LOG_QUERY = "INSERT INTO auditlog(`AuditLogId`,`AuditDate`,`Notes`,`HostName`,`LastModified`,`AuditActionId`,`CreatedDate`,`CreatedBy`,`AuditArea`) VALUES (NULL,{1},{2},{3},{4},{5},{6},{7},{8});SET {0} = LAST_INSERT_ID();";

        public static async Task InsertAudits(string connectionString)
        {
            int auditLogSeed = 0;
            StringBuilder queryBuilder = new();
            queryBuilder.AppendFormat(AUDIT_LOG_QUERY, $"@AuditLogId{auditLogSeed}", $"@AuditDate{auditLogSeed}", $"@Notes{auditLogSeed}", $"@HostName{auditLogSeed}", $"@LastModified{auditLogSeed}", $"@AuditActionId{auditLogSeed}", $"@CreatedDate{auditLogSeed}", $"@CreatedBy{auditLogSeed}", $"@AuditArea{auditLogSeed}");
            
            MySqlCommand cmd = new();
            cmd.Parameters.Add(new MySqlParameter($"@AuditDate{auditLogSeed}", DateTime.UtcNow));
            cmd.Parameters.Add(new MySqlParameter($"@Notes{auditLogSeed}", "Some notes"));
            cmd.Parameters.Add(new MySqlParameter($"@HostName{auditLogSeed}", "localhost"));
            cmd.Parameters.Add(new MySqlParameter($"@LastModified{auditLogSeed}", DateTime.UtcNow));
            cmd.Parameters.Add(new MySqlParameter($"@AuditActionId{auditLogSeed}", 1));
            cmd.Parameters.Add(new MySqlParameter($"@CreatedDate{auditLogSeed}", DateTime.UtcNow));
            cmd.Parameters.Add(new MySqlParameter($"@CreatedBy{auditLogSeed}", 1));
            cmd.Parameters.Add(new MySqlParameter($"@AuditArea{auditLogSeed}", "Notes"));

            using MySqlConnection conn = new (connectionString);
            conn.Open();
            using var transaction = conn.BeginTransaction();
            try
            {
                cmd.Connection = conn;
                cmd.CommandText = queryBuilder.ToString();
                cmd.CommandType = CommandType.Text;
                await cmd.ExecuteScalarAsync();
            }
            catch
            {
                transaction.Rollback();
                throw;
            }
        }
    }
}
